package org.cocktail.feve.components.fichedeposte;

// Generated by the WOLips TemplateEngine Plug-in at 14 nov. 2005 16:06:43

import java.math.BigDecimal;

import org.cocktail.feve.components.common.FeveWebComponent;
import org.cocktail.fwkcktlgrh.common.metier.EOAffectationDetail;
import org.cocktail.fwkcktlgrh.common.metier.EOFicheDePoste;
import org.cocktail.fwkcktlgrh.common.metier.EOStructureInfo;
import org.cocktail.fwkcktlwebapp.common.util.DateCtrl;
import org.cocktail.fwkcktlwebapp.common.util.StringCtrl;
import org.cocktail.ycrifwk.utils.UtilDb;

import com.webobjects.appserver.WOComponent;
import com.webobjects.appserver.WOContext;
import com.webobjects.foundation.NSTimestamp;

public class CompFicheDePosteEnvironnement extends FeveWebComponent {

	// variables entrantes
	private EOFicheDePoste inputLaFicheDePoste;
	private EOFicheDePoste inputLaFicheDePostePrecedente;
	private EOAffectationDetail eoAffectationDetailSelected;
	
		// infos structure
	public String newMissionComposante, newMissionService, newProjetService, newMissionPoste, newContexteTravail;
	private BigDecimal cotationPartF;
	public EOStructureInfo recMissionComposante, recMissionService, recProjetService;
	private NSTimestamp laDateRef;

	// temoin d'erreur
	public String errorMessage;

	public CompFicheDePosteEnvironnement(WOContext context) {
		super(context);
	}

	// setter

	/**
	 * Detection du changement du point d'entree -> RAZ si la fiche n'est plus la
	 * même
	 */
	public void setInputLaFicheDePoste(EOFicheDePoste value) {
		inputLaFicheDePostePrecedente = inputLaFicheDePoste;
		inputLaFicheDePoste = value;
		if (inputLaFicheDePoste != inputLaFicheDePostePrecedente) {
			recMissionComposante = null;
			recMissionService = null;
			recProjetService = null;
			newMissionComposante = null;		
			newMissionService = null;
			newProjetService = null;
			newMissionPoste = inputLaFicheDePoste.fdpMissionPoste();
			newContexteTravail = inputLaFicheDePoste.fdpContexteTravail();
			if (inputLaFicheDePoste.cotationPartF() != null) {
				cotationPartF = inputLaFicheDePoste.cotationPartF();
			} else {
				cotationPartF = BigDecimal.valueOf(0);
			}
			if (recMissionComposante() != null) {
				newMissionComposante = recMissionComposante().sinLibelle();
			}
			if (recMissionService() != null) {
				newMissionService = recMissionService().sinLibelle();
			}
			if (recProjetService() != null) {				
				newProjetService = recProjetService().sinLibelle();
			}
			newMissionPoste = inputLaFicheDePoste.fdpMissionPoste();
			newContexteTravail = inputLaFicheDePoste.fdpContexteTravail();
			laDateRef = null;
			errorMessage = null;
			ancreHaut();
		}
	}

	// getter

	public boolean hasError() {
		return !StringCtrl.isEmpty(errorMessage);
	}

	public EOFicheDePoste inputLaFicheDePoste() {
		return inputLaFicheDePoste;
	}

	private EOStructureInfo recMissionComposante() {
		if ((recMissionComposante == null) && (inputLaFicheDePoste.toPoste().toStructure().toComposante() != null)) {
			recMissionComposante = EOStructureInfo.findStructureInfoForStructureAndDateAndTypeInContext(
					ec,
					inputLaFicheDePoste.toPoste().toStructure().toComposante(),
					laDateRef(),
					EOStructureInfo.getTYPE_MISSION_COMPOSANTE());
			// si enregistrement inexistant -> creation
			if (recMissionComposante == null) {
				recMissionComposante = EOStructureInfo.newRecordInContext(
						ec,
						inputLaFicheDePoste.toPoste().toStructure().toComposante(),
						DateCtrl.now(),
						null,
						"",
						EOStructureInfo.getTYPE_MISSION_COMPOSANTE());
			}
		}
		return recMissionComposante;
	}

	private EOStructureInfo recMissionService() {
		if ( (recMissionService == null) && (inputLaFicheDePoste.toPoste().toStructure()!=null)) {
			recMissionService = EOStructureInfo.findStructureInfoForStructureAndDateAndTypeInContext(
					ec,
					inputLaFicheDePoste.toPoste().toStructure(),
					laDateRef(),
					EOStructureInfo.getTYPE_MISSION_SERVICE());
			// si enregistrement inexistant -> creation
			if (recMissionService == null) {
				recMissionService = EOStructureInfo.newRecordInContext(
						ec,
						inputLaFicheDePoste.toPoste().toStructure(),
						DateCtrl.now(),
						null,
						"",
						EOStructureInfo.getTYPE_MISSION_SERVICE());
			}
		}
		return recMissionService;
	}

	private EOStructureInfo recProjetService() {
		if ((recProjetService == null) && (inputLaFicheDePoste.toPoste().toStructure()!=null)) {
			recProjetService = EOStructureInfo.findStructureInfoForStructureAndDateAndTypeInContext(
					ec,
					inputLaFicheDePoste.toPoste().toStructure(),
					laDateRef(),
					EOStructureInfo.getTYPE_PROJET_SERVICE());
			// si enregistrement inexistant -> creation
			if (recProjetService == null) {
				recProjetService = EOStructureInfo.newRecordInContext(
						ec,
						inputLaFicheDePoste.toPoste().toStructure(),
						DateCtrl.now(),
						null,
						"",
						EOStructureInfo.getTYPE_PROJET_SERVICE());
			}
		}
		return recProjetService;
	}

	/**
	 * la date pour recuperer les infos des structure - si la date est la fiche en
	 * cours : today - si date passe, on prend la fin de la fiche
	 * 
	 * @return
	 */
	private NSTimestamp laDateRef() {
		if (laDateRef == null) {
			if (inputLaFicheDePoste.fdpDFin() != null && DateCtrl.isAfter(DateCtrl.now(), inputLaFicheDePoste.fdpDFin())) {
				laDateRef = inputLaFicheDePoste.fdpDFin();
			} else {
				laDateRef = DateCtrl.now();
			}
		}
		return laDateRef;
	}

	// PASSAGES D UN MODE A UN AUTRE

	public boolean isModeModifMissionComposante, isModeModif2, isModeModif3, isModeModif4, isModeModifFonctionEncadrement, isModeModif5, isModeModiCotationPartF;

	private void desactiverModeModif() {
		isModeModifMissionComposante = isModeModif2 = isModeModif3 = isModeModif4 = isModeModif5 = isModeModifFonctionEncadrement = isModeModiCotationPartF = false;
	}

	public WOComponent activerModeModifMissionComposante() {
		desactiverModeModif();
		ancreMissionComposante();
		isModeModifMissionComposante = true;
		return neFaitRien();
	}

	public WOComponent activerModeModif2() {
		desactiverModeModif();
		ancreMissionService();
		isModeModif2 = true;
		return neFaitRien();
	}

	public WOComponent activerModeModif3() {
		desactiverModeModif();
		ancreProjetService();
		isModeModif3 = true;
		return neFaitRien();
	}
	
	public WOComponent activerModeModifFonctionEncadrement() {
		desactiverModeModif();
		ancreFonctionEncadrement();
		isModeModifFonctionEncadrement = true;
		return neFaitRien();
	}

	public WOComponent activerModeModif4() {
		desactiverModeModif();
		ancreMissionPoste();
		isModeModif4 = true;
		return neFaitRien();
	}

	public WOComponent activerModeModif5() {
		desactiverModeModif();
		ancreContexteTravail();
		isModeModif5 = true;
		return neFaitRien();
	}

	public WOComponent activerModeModifCotationPartF() {
		desactiverModeModif();
		isModeModiCotationPartF = true;
		return neFaitRien();
	}
	
	
	public boolean isDisabledTexteMissionComposante() {
		return !isModeModifMissionComposante;
	}

	public boolean isDisabledTexte2() {
		return !isModeModif2;
	}

	public boolean isDisabledTexte3() {
		return !isModeModif3;
	}

	public boolean isDisabledTexte4() {
		return !isModeModif4;
	}

	public boolean isDisabledTexte5() {
		return !isModeModif5;
	}

	// DISPOS DES BOUTONS

	/**
	 * Disponibilité du bouton de modification du texte "mission de la composante"
	 */
	public boolean isDisabledBtnModifMissionComposante() {
		return verrouNiveauAgent() || verrouNiveauFiche() || isModeModif4 || isModeModif2 || isModeModif3 || isModeModif5 || isModeModiCotationPartF;
	}

	/**
	 * Droit de modification du texte de service
	 */
	public boolean isDisabledBtnModif2() {
		return verrouNiveauAgent() || verrouNiveauFiche() || isModeModifMissionComposante || isModeModif4 || isModeModif3 || isModeModif5 || isModeModiCotationPartF;
	}

	/**
	 * Droit de modification du texte de service
	 */
	public boolean isDisabledBtnModif3() {
		return verrouNiveauAgent() || verrouNiveauFiche() || isModeModifMissionComposante || isModeModif2 || isModeModif4 || isModeModif5 || isModeModiCotationPartF;
	}
	
	
	/**
	 * Droit de modification ddes fonctions d'encadrements
	 */
	public boolean isDisabledBtnModifFonctionEncadrement() {
		return verrouNiveauAgent() || verrouNiveauFiche() || isModeModifMissionComposante || isModeModif2 || isModeModif4 || isModeModif5 || isModeModif3 || isModeModiCotationPartF;
	}
	

	/**
	 * Retourne vrai si la personne connectee n'a pas les droits de faire de
	 * modifications sur cette fiche
	 */
	private boolean verrouNiveauAgent() {
		if (getEoAffectationDetailSelected() != null) {
			return !feveUserInfo().getAutorisation().hasDroitUtilisationGererFichePoste(getEoAffectationDetailSelected().toAffectation().toIndividu());
		} else {
			return !feveUserInfo().getAutorisation().hasDroitUtilisationGererFichePoste(inputLaFicheDePoste().toPoste().toStructure());
		}
		
	}

	/**
	 * Retourne vrai si la fiche n'est pas modifiable a cause de son contenu. Une
	 * Fiche de poste n'est modifiable que si aucun visa n'a ete fait
	 */
	private boolean verrouNiveauFiche() {
		return inputLaFicheDePoste().fdpVisaAgentBool() ||
				inputLaFicheDePoste().fdpVisaRespBool() ||
				inputLaFicheDePoste().fdpVisaDirecBool();
	}

	public boolean isDisabledBtnModif4() {
		return verrouNiveauAgent() || verrouNiveauFiche() || isModeModifMissionComposante || isModeModif2 || isModeModif3 || isModeModif5 || isModeModiCotationPartF;
	}

	public boolean isDisabledBtnModif5() {
		return verrouNiveauAgent() || verrouNiveauFiche() || isModeModifMissionComposante || isModeModif2 || isModeModif3 || isModeModif4 || isModeModiCotationPartF;
	}

	public boolean isDisabledBtnModiCotationPartF() {
		return verrouNiveauAgent() || verrouNiveauFiche() || isModeModifMissionComposante || isModeModif2 || isModeModif3 || isModeModif4 || isModeModif5 || isModeModiCotationPartF;
	}
	
	// datas

	private WOComponent sauvegarder() throws Throwable {
		UtilDb.save(ec, "");
		desactiverModeModif();
		errorMessage = null;
		return neFaitRien();
	}

	public WOComponent annulerModifMissionComposante() {
		newMissionComposante = recMissionComposante().sinLibelle();
		return annulerModif();
	}

	public WOComponent annulerModifMissionService() {
		newMissionService = recMissionService().sinLibelle();
		;
		return annulerModif();
	}

	public WOComponent annulerModifProjetService() {
		newProjetService = recProjetService().sinLibelle();
		return annulerModif();
	}
	
	public WOComponent annulerModifFonctionEncadrement() {
		//TODO
		return annulerModif();
	}

	public WOComponent annulerModifContexteTravail() {
		newContexteTravail = inputLaFicheDePoste.fdpContexteTravail();
		return annulerModif();
	}
	
	public WOComponent annulerModifCotationPartF() {
		if (inputLaFicheDePoste.cotationPartF() != null) {
			cotationPartF = inputLaFicheDePoste.cotationPartF();
		} else {
			cotationPartF = BigDecimal.valueOf(0);
		}
		return annulerModif();
	}

	public WOComponent annulerModifMissionPoste() {
		newMissionPoste = inputLaFicheDePoste.fdpMissionPoste();
		return annulerModif();
	}

	private WOComponent annulerModif() {
		ec.revert();
		desactiverModeModif();
		errorMessage = null;
		return neFaitRien();
	}

	public WOComponent enregistrerMissionComposante() throws Throwable {
		if (session.feveDataBus().checkForMaxSize(EOStructureInfo.ENTITY_NAME, EOStructureInfo.SIN_LIBELLE_KEY,
				newMissionComposante, "Mission composante", 0, true)) {
			recMissionComposante().setSinLibelle(newMissionComposante);
			sauvegarder();
		} else {
			ancreHaut();
			errorMessage = session.feveDataBus().getErrorMessage();
		}
		return null;
	}

	public WOComponent enregistrerMissionService() throws Throwable {
		if (session.feveDataBus().checkForMaxSize(EOStructureInfo.ENTITY_NAME, EOStructureInfo.SIN_LIBELLE_KEY,
				newMissionService, "Mission service", 0, true)) {
			recMissionService().setSinLibelle(newMissionService);
			sauvegarder();
		} else {
			ancreHaut();
			errorMessage = session.feveDataBus().getErrorMessage();
		}
		return null;
	}

	public WOComponent enregistrerProjetService() throws Throwable {
		if (session.feveDataBus().checkForMaxSize(EOStructureInfo.ENTITY_NAME, EOStructureInfo.SIN_LIBELLE_KEY,
				newProjetService, "Projet service", 0, true)) {
			recProjetService().setSinLibelle(newProjetService);
			sauvegarder();
		} else {
			ancreHaut();
			errorMessage = session.feveDataBus().getErrorMessage();
		}
		return null;
	}
	
	public WOComponent enregistrerFonctionEncadrement() throws Throwable {		
		if ("O".equals(inputLaFicheDePoste.fonctionEncadrement())
				&& inputLaFicheDePoste.nbAgentsEncadres() == null
				&& inputLaFicheDePoste.nbAgentsEncadresCategorieA() == null
				&& inputLaFicheDePoste.nbAgentsEncadresCategorieA() == null
				&& inputLaFicheDePoste.nbAgentsEncadresCategorieA() == null) {			  
			session.feveDataBus().setErrorMessage("Dans le cas de fonction d'encadrement, vous devez préciser le nombre et la répartion des agents");
			errorMessage = session.feveDataBus().getErrorMessage();
			return null;
		}

		if ("O".equals(inputLaFicheDePoste.fonctionEncadrement()) && inputLaFicheDePoste.nbAgentsEncadres() == null)
		{			  
			inputLaFicheDePoste.setNbAgentsEncadres(new Integer(0));
		}

		if ("O".equals(inputLaFicheDePoste.fonctionEncadrement()) && inputLaFicheDePoste.nbAgentsEncadresCategorieA() == null)			
		{			  
			inputLaFicheDePoste.setNbAgentsEncadresCategorieA(new Integer(0));
		}

		if ("O".equals(inputLaFicheDePoste.fonctionEncadrement()) && inputLaFicheDePoste.nbAgentsEncadresCategorieB() == null)			
		{			  
			inputLaFicheDePoste.setNbAgentsEncadresCategorieB(new Integer(0));
		}

		if ("O".equals(inputLaFicheDePoste.fonctionEncadrement()) && inputLaFicheDePoste.nbAgentsEncadresCategorieC() == null)			
		{			  
			inputLaFicheDePoste.setNbAgentsEncadresCategorieC(new Integer(0));
		}

		errorMessage = "";
		isModeModifFonctionEncadrement = false;

		if ("N".equals(inputLaFicheDePoste.fonctionEncadrement())) {
			inputLaFicheDePoste.setNbAgentsEncadres(null);
			inputLaFicheDePoste.setNbAgentsEncadresCategorieA(null);
			inputLaFicheDePoste.setNbAgentsEncadresCategorieB(null);
			inputLaFicheDePoste.setNbAgentsEncadresCategorieC(null);
		}
		sauvegarde();
		return null;
	}


	public WOComponent enregistrerMissionPoste() throws Throwable {
		if (session.feveDataBus().checkForMaxSize(EOFicheDePoste.ENTITY_NAME, EOFicheDePoste.FDP_MISSION_POSTE_KEY,
				newMissionPoste, "Mission poste", 0, true)) {
			inputLaFicheDePoste().setFdpMissionPoste(newMissionPoste);
			sauvegarder();
		} else {
			ancreHaut();
			errorMessage = session.feveDataBus().getErrorMessage();
		}
		return null;
	}

	public WOComponent enregistrerContexteTravail() throws Throwable {
		if (session.feveDataBus().checkForMaxSize(EOFicheDePoste.ENTITY_NAME, EOFicheDePoste.FDP_CONTEXTE_TRAVAIL_KEY,
				newContexteTravail, "Contexte travail", 0, true)) {
			inputLaFicheDePoste().setFdpContexteTravail(newContexteTravail);
			sauvegarder();
		} else {
			ancreHaut();
			errorMessage = session.feveDataBus().getErrorMessage();
		}
		return null;
	}
	
	
	public WOComponent enregistrerCotationPartF() throws Throwable {
		if (cotationPartF.compareTo(BigDecimal.valueOf(0)) >= 0 && cotationPartF.compareTo(BigDecimal.valueOf(999)) <= 0) {
			inputLaFicheDePoste.setCotationPartF(cotationPartF);
			sauvegarder();
		} else {
			annulerModifCotationPartF();
			desactiverModeModif();
			session.feveDataBus().setErrorMessage("La valeur doit être comprise entre 0 et 999");
			errorMessage = session.feveDataBus().getErrorMessage();
		}
		
		return null;
	}
	

	// GESTION DES ANCRES

	public final String ANCRE_MISSION_COMPOSANTE = "amc";
	public final String ANCRE_MISSION_SERVICE = "ams";
	public final String ANCRE_PROJET_SERVICE = "aps";
	public final String ANCRE_MISSION_POSTE = "amp";
	public final String ANCRE_FONCTION_ENCADREMENT = "afe";
	public final String ANCRE_CONTEXTE_TRAVAIL = "act";

	private void ancreHaut() {
		session.setOnLoad("");
	}

	private void ancreMissionComposante() {
		session.setOnLoad("document.location='#" + ANCRE_MISSION_COMPOSANTE + "';");
		;
	}

	private void ancreMissionService() {
		session.setOnLoad("document.location='#" + ANCRE_MISSION_COMPOSANTE + "';");
		;
	}

	private void ancreProjetService() {
		session.setOnLoad("document.location='#" + ANCRE_PROJET_SERVICE + "';");
		;
	}
	
	private void ancreFonctionEncadrement() {
		session.setOnLoad("document.location='#" + ANCRE_FONCTION_ENCADREMENT + "';");
		;
	}

	private void ancreMissionPoste() {
		session.setOnLoad("document.location='#" + ANCRE_MISSION_POSTE + "';");
		;
	}

	private void ancreContexteTravail() {
		session.setOnLoad("document.location='#" + ANCRE_CONTEXTE_TRAVAIL + "';");
		;
	}

	/**
	 * Permet de savoir si l'agent à des fonctions d'encadrement.
	 * @return true si l'agent à des fonctions d'encadrement.
	 */
	public boolean isFonctionEncadrement() {
		return (inputLaFicheDePoste.fonctionEncadrement().equals("O"));
	}

	public boolean isNotFonctionEncadrement() {
		return !(isFonctionEncadrement());
	}

	
	public boolean isNotModeModifFonctionEncadrement() {
		return !isModeModifFonctionEncadrement;
	}
	
	public String ajaxUpdateFonctionEncadrementID() {
		return getComponentId() + "_ajaxUpdateFonctionEncadrement";
	}
	
	
	/**
	 * @return the conduiteProjet
	 */
	public boolean ConduiteProjet() {
		return ("O".equals(inputLaFicheDePoste.fonctionConduiteProjet()));			
	}

	/**
	 * @param conduiteProjet the conduiteProjet to set
	 */
	public void setConduiteProjet(boolean value) {
		inputLaFicheDePoste.setFonctionConduiteProjet((value)?"O":"N");
	}

	/**
	 * @return the fctEncadrement
	 */
	public boolean selectionFctEncadrement() {
		return ("O".equals(inputLaFicheDePoste.fonctionEncadrement()));			
	}

	/**
	 * @param fctEncadrement the fctEncadrement to set
	 */
	public void setSelectionFctEncadrement(boolean value) {
		inputLaFicheDePoste.setFonctionEncadrement((value)?"O":"N");
	}

	public boolean isNotModeModiCotationPartF() {
		return !isModeModiCotationPartF;
	}
	
	
	public void setCotationPartF(BigDecimal value) {
		cotationPartF = value;
//		Integer.valueOf(value);
	}
	
	public BigDecimal getCotationPartF() {
		return cotationPartF;
	}

	public EOAffectationDetail getEoAffectationDetailSelected() {
		return eoAffectationDetailSelected;
	}

	public void setEoAffectationDetailSelected(
			EOAffectationDetail eoAffectationDetailSelected) {
		this.eoAffectationDetailSelected = eoAffectationDetailSelected;
	}
	
}